# FoundationClasses
TKAdvTools
Expr

# Expr_BinaryExpression Class Reference

Defines all binary expressions. The order of the two
operands is significant.
.

`#include <Expr_BinaryExpression.hxx>`

Inheritance diagram for Expr_BinaryExpression:

[legend]

## Public Member Functions

const Handle_Expr_GeneralExpression & | FirstOperand () const
const Handle_Expr_GeneralExpression & | SecondOperand () const
Standard_EXPORT void | SetFirstOperand (const Handle(Expr_GeneralExpression)&exp)
| Sets first operand of <me> Raises InvalidOperand if exp = me .
Standard_EXPORT void | SetSecondOperand (const Handle(Expr_GeneralExpression)&exp)
| Sets second operand of <me> Raises InvalidOperand if <exp> contains <me>. .
Standard_EXPORT Standard_Integer | NbSubExpressions () const
| returns the number of sub-expressions contained in <me> ( >= 0)
Standard_EXPORT const Handle_Expr_GeneralExpression & | SubExpression (const Standard_Integer I) const
| returns the -th sub-expression of <me> raises OutOfRange if > NbSubExpressions(me)
Standard_EXPORT Standard_Boolean | ContainsUnknowns () const
| Does <me> contain NamedUnknown ? .
Standard_EXPORT Standard_Boolean | Contains (const Handle(Expr_GeneralExpression)&exp) const
| Tests if <me> contains <exp>. .
Standard_EXPORT void | Replace (const Handle(Expr_NamedUnknown)&var, const Handle(Expr_GeneralExpression)&with)
| Replaces all occurences of with <with> in <me>. Raises InvalidOperand if <with> contains <me>. .
Standard_EXPORT Handle_Expr_GeneralExpression | Simplified () const
| Returns a GeneralExpression after replacement of NamedUnknowns by an associated expression and after values computation. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Protected Member Functions

Standard_EXPORT void | CreateFirstOperand (const Handle(Expr_GeneralExpression)&exp)
| Sets first operand of <me> .
Standard_EXPORT void | CreateSecondOperand (const Handle(Expr_GeneralExpression)&exp)
| Sets second operand of <me> Raises InvalidOperand if <exp> contains <me>. .

## Private Attributes

Handle_Expr_GeneralExpression | myFirstOperand
Handle_Expr_GeneralExpression | mySecondOperand

## Member Function Documentation

Standard_EXPORT Standard_Boolean Expr_BinaryExpression::Contains | ( | const Handle(Expr_GeneralExpression)& | exp | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT Standard_Boolean Expr_BinaryExpression::ContainsUnknowns | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT void Expr_BinaryExpression::CreateFirstOperand | ( | const Handle(Expr_GeneralExpression)& | exp | ) | `[protected]`

Standard_EXPORT void Expr_BinaryExpression::CreateSecondOperand | ( | const Handle(Expr_GeneralExpression)& | exp | ) | `[protected]`

const Handle_Expr_GeneralExpression& Expr_BinaryExpression::FirstOperand | ( |  | ) | const

Standard_EXPORT const Expr_BinaryExpression::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from Expr_GeneralExpression. Reimplemented in Expr_BinaryFunction, Expr_Difference, Expr_Division, and Expr_Exponentiate.

Standard_EXPORT Standard_Integer Expr_BinaryExpression::NbSubExpressions | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT void Expr_BinaryExpression::Replace | ( | const Handle(Expr_NamedUnknown)& | var,
|  | const Handle(Expr_GeneralExpression)& | with
| ) | `[virtual]`

| Implements Expr_GeneralExpression.

const Handle_Expr_GeneralExpression& Expr_BinaryExpression::SecondOperand | ( |  | ) | const

Standard_EXPORT void Expr_BinaryExpression::SetFirstOperand | ( | const Handle(Expr_GeneralExpression)& | exp | ) |

Standard_EXPORT void Expr_BinaryExpression::SetSecondOperand | ( | const Handle(Expr_GeneralExpression)& | exp | ) |

Standard_EXPORT Handle_Expr_GeneralExpression Expr_BinaryExpression::Simplified | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT const Handle_Expr_GeneralExpression& Expr_BinaryExpression::SubExpression | ( | const Standard_Integer | I | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

## Field Documentation

Handle_Expr_GeneralExpression Expr_BinaryExpression::myFirstOperand `[private]`

Handle_Expr_GeneralExpression Expr_BinaryExpression::mySecondOperand `[private]`

The documentation for this class was generated from the following file:

- Expr_BinaryExpression.hxx